/*
 *   This file is a part of the SteamWar software.
 *
 *   Copyright (C) 2025 SteamWar.de-Serverteam
 *
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Affero General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *   GNU Affero General Public License for more details.
 *
 *   You should have received a copy of the GNU Affero General Public License
 *   along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

package de.steamwar.lobby.map;

import org.bukkit.map.MapPalette;

import java.awt.*;
import java.io.InputStream;

public class ColorInit {

    private static final byte[] colors;

    public static int getColor(int r, int g, int b) {
        return colors[(r << 16) + (g << 8) + b] & 0xFF;
    }

    public static byte getColorByte(int r, int g, int b) {
        return colors[(r << 16) + (g << 8) + b];
    }

    static {
        long time = System.currentTimeMillis();
        InputStream inputStream = ColorInit.class.getResourceAsStream("/colors.nearest");
        if (inputStream == null) {
            colors = new byte[256 * 256 * 256];
            for (int i = 0; i < colors.length; i++) {
                colors[i] = MapPalette.matchColor(new Color(i));
            }
        } else {
            try {
                byte[] bytes = inputStream.readAllBytes();
                if (bytes.length != 256 * 256 * 256) {
                    throw new RuntimeException("Invalid colors.nearest file");
                }
                colors = bytes;
            } catch (Exception e) {
                throw new RuntimeException("Failed to read colors.nearest file", e);
            }
        }
        System.out.println("[ColorInit] Initialization took " + (System.currentTimeMillis() - time) + "ms");
    }
}
